"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationHostnameStrategy = void 0;
var os_1 = require("os");
var strategy_1 = require("./strategy");
var helper_1 = require("./helper");
var ApplicationHostnameStrategy = /** @class */ (function (_super) {
    __extends(ApplicationHostnameStrategy, _super);
    function ApplicationHostnameStrategy() {
        var _this = _super.call(this, 'applicationHostname') || this;
        _this.hostname = (process.env.HOSTNAME || os_1.hostname() || 'undefined').toLowerCase();
        return _this;
    }
    ApplicationHostnameStrategy.prototype.isEnabled = function (parameters, context) {
        var listType = helper_1.getListType(parameters);
        if (listType === 'blacklist') {
            if (!parameters.hostNames) {
                return true;
            }
            return !JSON.parse(parameters.hostNames)
                .toLowerCase()
                .split(/\s*,\s*/)
                .filter(function (s) { return s; })
                .includes(this.hostname);
        }
        // 默认白名单处理
        if (!parameters.hostNames) {
            return false;
        }
        return JSON.parse(parameters.hostNames)
            .toLowerCase()
            .split(/\s*,\s*/)
            .filter(function (s) { return s; })
            .includes(this.hostname);
    };
    return ApplicationHostnameStrategy;
}(strategy_1.Strategy));
exports.ApplicationHostnameStrategy = ApplicationHostnameStrategy;
//# sourceMappingURL=application-hostname-strategy.js.map