"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.GradualRolloutCustomProperty = void 0;
var strategy_1 = require("./strategy");
var helper_1 = require("./helper");
var GradualRolloutCustomProperty = /** @class */ (function (_super) {
    __extends(GradualRolloutCustomProperty, _super);
    function GradualRolloutCustomProperty() {
        return _super.call(this, 'gradualRolloutCustomProperty') || this;
    }
    GradualRolloutCustomProperty.prototype.isEnabled = function (parameters, context) {
        var percentage = 0;
        try {
            percentage = Number(JSON.parse(parameters.percentage));
            if (percentage >= 100) {
                return true;
            }
        }
        catch (error) {
            return false;
        }
        if (!parameters.propertyName) {
            return false;
        }
        var propertyName = JSON.parse(parameters.propertyName);
        if (!context.properties || !context.properties[propertyName]) {
            return false;
        }
        var propertyValue = context.properties[propertyName];
        var groupId = JSON.parse(parameters.groupId) || '';
        var normalizedId = helper_1.normalizedValue(propertyValue, groupId);
        return percentage > 0 && normalizedId <= percentage;
    };
    return GradualRolloutCustomProperty;
}(strategy_1.Strategy));
exports.GradualRolloutCustomProperty = GradualRolloutCustomProperty;
//# sourceMappingURL=gradual-rollout-custom-property.js.map