"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.GradualRolloutSessionIdStrategy = void 0;
var strategy_1 = require("./strategy");
var helper_1 = require("./helper");
var GradualRolloutSessionIdStrategy = /** @class */ (function (_super) {
    __extends(GradualRolloutSessionIdStrategy, _super);
    function GradualRolloutSessionIdStrategy() {
        return _super.call(this, 'gradualRolloutSessionId') || this;
    }
    GradualRolloutSessionIdStrategy.prototype.isEnabled = function (parameters, context) {
        var percentage = 0;
        try {
            percentage = Number(JSON.parse(parameters.percentage));
            if (percentage >= 100) {
                return true;
            }
        }
        catch (error) {
            return false;
        }
        var sessionId = context.sessionId;
        if (!sessionId) {
            return false;
        }
        var groupId = JSON.parse(parameters.groupId) || '';
        var normalizedId = helper_1.normalizedValue(sessionId, groupId);
        return percentage > 0 && normalizedId <= percentage;
    };
    return GradualRolloutSessionIdStrategy;
}(strategy_1.Strategy));
exports.GradualRolloutSessionIdStrategy = GradualRolloutSessionIdStrategy;
//# sourceMappingURL=gradual-rollout-session-id.js.map