"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultStrategies = void 0;
var default_strategy_1 = require("./default-strategy");
var application_hostname_strategy_1 = require("./application-hostname-strategy");
var gradual_rollout_random_1 = require("./gradual-rollout-random");
var gradual_rollout_user_id_1 = require("./gradual-rollout-user-id");
var gradual_rollout_session_id_1 = require("./gradual-rollout-session-id");
var user_with_id_strategy_1 = require("./user-with-id-strategy");
var remote_address_strategy_1 = require("./remote-address-strategy");
var user_id_tail_number_strategy_1 = require("./user-id-tail-number-strategy");
var custom_property_1 = require("./custom-property");
var custom_kv_property_1 = require("./custom-kv-property");
var gradual_rollout_custom_property_1 = require("./gradual-rollout-custom-property");
var strategy_1 = require("./strategy");
Object.defineProperty(exports, "Strategy", { enumerable: true, get: function () { return strategy_1.Strategy; } });
exports.defaultStrategies = [
    new default_strategy_1.DefaultStrategy(),
    new application_hostname_strategy_1.ApplicationHostnameStrategy(),
    new gradual_rollout_random_1.GradualRolloutRandomStrategy(),
    new gradual_rollout_user_id_1.GradualRolloutUserIdStrategy(),
    new gradual_rollout_session_id_1.GradualRolloutSessionIdStrategy(),
    new user_with_id_strategy_1.UserWithIdStrategy(),
    new remote_address_strategy_1.RemoteAddressStrategy(),
    new user_id_tail_number_strategy_1.UserIdTailNumberStrategy(),
    new custom_property_1.CustomPropertyStrategy(),
    new custom_kv_property_1.CustomKVPropertyStrategy(),
    new gradual_rollout_custom_property_1.GradualRolloutCustomProperty(),
];
//# sourceMappingURL=index.js.map