"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemoteAddressStrategy = void 0;
var strategy_1 = require("./strategy");
var ip_1 = require("ip");
var helper_1 = require("./helper");
var RemoteAddressStrategy = /** @class */ (function (_super) {
    __extends(RemoteAddressStrategy, _super);
    function RemoteAddressStrategy() {
        return _super.call(this, 'remoteAddress') || this;
    }
    RemoteAddressStrategy.prototype.isEnabled = function (parameters, context) {
        var listType = helper_1.getListType(parameters);
        if (!parameters.IPs || !context.remoteAddress) {
            return listType === 'blacklist';
        }
        for (var _i = 0, _a = JSON.parse(parameters.IPs)
            .split(/\s*,\s*/)
            .filter(function (s) { return s; }); _i < _a.length; _i++) {
            var range = _a[_i];
            try {
                if (range === context.remoteAddress) {
                    return listType !== 'blacklist';
                }
                if (!ip_1.isV6Format(range)) {
                    if (ip_1.cidrSubnet(range).contains(context.remoteAddress)) {
                        return listType !== 'blacklist';
                    }
                }
            }
            catch (e) {
                continue;
            }
        }
        return listType === 'blacklist';
    };
    return RemoteAddressStrategy;
}(strategy_1.Strategy));
exports.RemoteAddressStrategy = RemoteAddressStrategy;
//# sourceMappingURL=remote-address-strategy.js.map