"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserIdTailNumberStrategy = void 0;
var strategy_1 = require("./strategy");
var helper_1 = require("./helper");
var constants = require("../constants");
var UserIdTailNumberStrategy = /** @class */ (function (_super) {
    __extends(UserIdTailNumberStrategy, _super);
    function UserIdTailNumberStrategy() {
        return _super.call(this, 'userIdTailNumber') || this;
    }
    UserIdTailNumberStrategy.prototype.isEnabled = function (parameters, context) {
        var listType = helper_1.getListType(parameters);
        if (!parameters.userIdTailNum || !context.userId) {
            return listType === constants.BLACK_LIST;
        }
        var userIdTailNumList = JSON.parse(parameters.userIdTailNum)
            .split(/\s*,\s*/)
            .filter(function (s) { return s; });
        for (var _i = 0, userIdTailNumList_1 = userIdTailNumList; _i < userIdTailNumList_1.length; _i++) {
            var userIdTailNum = userIdTailNumList_1[_i];
            if (context.userId.endsWith(userIdTailNum)) {
                return listType !== constants.BLACK_LIST;
            }
        }
        return listType === constants.BLACK_LIST;
    };
    return UserIdTailNumberStrategy;
}(strategy_1.Strategy));
exports.UserIdTailNumberStrategy = UserIdTailNumberStrategy;
//# sourceMappingURL=user-id-tail-number-strategy.js.map