"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserWithIdStrategy = void 0;
var strategy_1 = require("./strategy");
var helper_1 = require("./helper");
var constants = require("../constants");
var UserWithIdStrategy = /** @class */ (function (_super) {
    __extends(UserWithIdStrategy, _super);
    function UserWithIdStrategy() {
        return _super.call(this, 'userWithId') || this;
    }
    UserWithIdStrategy.prototype.isEnabled = function (parameters, context) {
        var listType = helper_1.getListType(parameters);
        if (!parameters.userIds || !context.userId) {
            return listType === constants.BLACK_LIST;
        }
        var userIdList = JSON.parse(parameters.userIds)
            .split(/\s*,\s*/)
            .filter(function (s) { return s; });
        if (listType === constants.BLACK_LIST) {
            return !userIdList.includes(context.userId);
        }
        return userIdList.includes(context.userId);
    };
    return UserWithIdStrategy;
}(strategy_1.Strategy));
exports.UserWithIdStrategy = UserWithIdStrategy;
//# sourceMappingURL=user-with-id-strategy.js.map